function [Output,dekey]=PSCSencryption(Input,Key,Mode)

% FUNCTION chaosencryption: encrypt/decryt a n-by-m gray image
% using Key.
%Implementor: Long Bao     Macau University R202 19/12/2012
% =========================================================================
% INPUTS: 
%           Input = a n-by-m gray image
%             Key = [a u r ori X0]
%            Mode =  ENC   DEC
% OUTPUTS:
%          Output = a n-by-m gray image
%
% =========================================================================
% DEMO:
% M = double(imread('lena.bmp'));
% K = [0.99 1.99 3.99 0.1 0.3];
% [E,K1] = PSCSencryption(M,K,'ENC');
% [D,K2] = PSCSencryption(E,K1,'DEC');
% subplot(131),imshow(M,[]),title('Original')
% subplot(132),imshow(E,[]),title('Encrypted')
% subplot(133),imshow(D,[]),title('Decrypted')
% =========================================================================

P=Input;
[W L C]=size(P)
p=0;k=0;F=256
P=double(P);
r=Key(3);
u=Key(2);
a=Key(1);
ori=Key(4)
z5=Key(5);
Num_iter=1;z3=[u,a,z5];
switch Mode
    case 'ENC' % Encryption
z2=r;
s=sum(sum(P))/100000000;
s=s-floor(s);(ori+s)/2
z1(1)=(ori+s)/2;
    for a=1:L*W+W+L 
           z1(a+1)=z1(a)*(1-z1(a))*z2;
    end
q(z1>0.5)=1;
q(z1<=0.5)=0;
k0=q;sum(q)
z3(3)=z5;
e=keygen(W*L+W+L,k0,z3);s1=e(1:W*L);
ps=substitution(W,L,s1,P);
ps1=ps;
s0=e(W*L+1:W*L+W+L);
pp=permutation1(W,L,s0,ps1);
pp1=pp;

for iteration=1:Num_iter
z1(1)=(z1(1)+z5)/2;
    for a=1:L*W+W+L
           z1(a+1)=z1(a)*(1-z1(a))*z2;
    end
q(z1>0.5)=1;
q(z1<=0.5)=0;
k1=q;sum(q)
z3(3)=z5;
e=keygen(W*L+W+L,k1,z3);s2=e(1:W*L);
ps=substitution(W,L,s2,pp1);
ps2=ps;
s3=e(W*L+1:W*L+W+L);
pp=permutation1(W,L,s3,ps2);
pp1=pp;
end

    case 'DEC' %% decryption
pp1=P;
z2=r;
z1(1)=ori;
for iteration=1:(Num_iter+1)
    for a=1:L*W+W+L
        if(z1(a)<=0.5)
            q(a)=0;
        else q(a)=1;
        end  
           z1(a+1)=z1(a)*(1-z1(a))*z2;
    end
k1=q;sum(q)
z3(3)=z5;
e=keygen(W+L+W*L,k1,z3);s1=e(W*L+1:W*L+W+L);
pp=depermutation11(W,L,s1,pp1);
pp2=pp;
s0=e(1:W*L);
ps=desubstitution(W,L,s0,pp2);
pp1=ps;
z1(1)=2*z1(1)-z5;
end
end
Output=pp1;
dekey=Key;
dekey(4)=z1(1)
